/*
 * Filename:	include/cameo/ipv4_arp.h	
 * Author:	arrow <jianzhang@nettech-global.com>
 * Created at:	Sun Aug 23 18:49:23 2009
 ******************************************************************************/
#ifndef _CAMEO_IPV4_LOG_H
#define _CAMEO_IPV4_LOG_H

#include <linux/types.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/kernel.h>
#include <cameo/define.h>


#ifdef CONFIG_LOG_NETFILTER
void log_netfilter(struct sk_buff **skb, int hook,
			const struct net_device *indev,
			const struct net_device *outdev,
			unsigned int action);
#else
#    define log_netfilter(...) do {} while(0)
#endif

/* compare with 0 is fast, for it is a single instruction, compare with 0 is
 * clear with our think, so */
#define intfdrop_log(fmt, __argv...) do { \
	if ((log_netfilter_enable != 0) && printk_ratelimit()) { \
		printk(fmt, ##__argv); \
	} \
} while (0)

#endif


